package com.mortals.xhx.common.code;

import java.util.LinkedHashMap;
import java.util.Map;

/**
* 数据类型（number.数字,string.字符串）枚举类
*
* @author zxfei
*/
public enum AppFieldTypeEnum {
    INPUT("input", "单行输入框"),
    TEXTAREA("textarea", "多行输入框"),
    SELECT("select", "下拉选项框"),
    DATE("date", "日期选择框"),
    EDITOR("editor", "富文本"),
    ;
    private String value;
    private String desc;

    AppFieldTypeEnum(String value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getValue() {
        return this.value;
    }

    public String getDesc() {
        return this.desc;
    }

    public static AppFieldTypeEnum getByValue(String value) {
        for (AppFieldTypeEnum dataTypeEnum : AppFieldTypeEnum.values()) {
            if (dataTypeEnum.getValue() == value) {
                return dataTypeEnum;
            }
        }
        return null;
    }

    /**
    * 获取Map集合
    *
    * @param eItem 不包含项
    * @return
    */
    public static Map<String, String> getEnumMap(String... eItem) {
        Map<String, String> resultMap = new LinkedHashMap<>();
        for (AppFieldTypeEnum item : AppFieldTypeEnum.values()) {
            try {
                boolean hasE = false;
                for (String e : eItem) {
                    if (item.getValue() == e) {
                        hasE = true;
                        break;
                    }
                }
                if (!hasE) {
                    resultMap.put(item.getValue() + "", item.getDesc());
                }
            } catch (Exception ex) {

            }
        }
        return resultMap;
    }
}